import numpy as np
import pandas as pd
import matplotlib.pyplot as plt 
import datetime as dt 
import os as os



def get_substorms(prod):
	path_base = '' #enter filepath where data repo is located
	
	prod_ = prod
	st_event = pd.to_datetime(prod_['st'])
	yr = str(st_event.dt.year[0])
	onsets = pd.read_csv(path_base+'prod_init/Substorm Lists/'+'substorms-newell-'+yr+'0101_000000_to_'+yr+'1231_000000.csv', header=0)
	st_onset = pd.to_datetime(onsets['Date_UTC'])
	tla_substorms = []


	for i in np.arange(0, len(st_onset)):


		diff = pd.DataFrame(st_onset[i] - st_event)
		diff['abs_diff'] = diff['st'].abs()
		mindex = diff['abs_diff'].idxmin(axis=0)
		onset_td = diff['abs_diff'].iloc[mindex]
		onset_diffmins = onset_td.total_seconds()/60

		if onset_diffmins <= 30:
			tla_substorms.append(onsets.loc[i, :])

	# tla_substorms = pd.concat(tla_substorms, axis=0)
	# tla_substorms.columns = ['Date_UTC', 'MLT', 'MLAT', 'GLON', 'GLAT']
	tla_substorms = pd.DataFrame(tla_substorms)
	print(tla_substorms)

	tla_substorms.to_csv(path_base+'TLA Substorms' \
						'TLA_substorms-newell-'+yr+'0101_000000_to_'+yr+'1231_000000.csv', \
						index=False)
	return 





path_base = '/' #enter filepath where data repo is located before 
# the 'prod_init/Products/' 

file_base = '_algfinal_2-60s_6-1000nT_6-100nTs_xyz_filterf_svmvote_chk'

def load_products(year):
	prod_list = []
	for file in os.listdir(path_base+'/Products/'+year+'/'):
		if file.endswith('.csv'):
			prod_list.append(pd.read_csv(path_base+'/Products/'+year+'/'+file, header=0))
	df = pd.concat(prod_list, ignore_index=True)
	df.drop(['Unnamed: 0'], axis=1, inplace=True)

	return df

prod_09 = load_products('2009')
prod_10 = load_products('2010')
prod_11 = load_products('2011')
prod_12 = load_products('2012')
prod_13 = load_products('2013')
prod_14 = load_products('2014')
prod_15 = load_products('2015')
prod_16 = load_products('2016')
prod_17 = load_products('2017')
prod_18 = load_products('2018')
prod_19 = load_products('2019')


print(prod_09)

get_substorms(prod_09)
get_substorms(prod_10)
get_substorms(prod_11)
get_substorms(prod_12)
get_substorms(prod_13)
get_substorms(prod_14)
get_substorms(prod_15)
get_substorms(prod_16)
get_substorms(prod_17)
get_substorms(prod_18)
get_substorms(prod_19)
